/* Light Speed Reference Example Program */
/* Write a string, with a character in each font */
#include "lspeed.h"

main()
{
   /* Variables */
   int loop;

   /* Set graphics mode and register all fonts */
   set640x350();
   registerbroadfont();
   registercomputerfont();
   registertallfont();
   registersmallfont();
   registerscriptfont();
   registerplasmafont();
   registerplainfont();
   registeroldenglishfont();
   registernicefont();
   registeritalicfont();
   registerstandardfont();
   registercrispfont();

   /* Write a YELLOW string, with a character in each font */
   ega_writecharacter('H', 10, 10, LS_YELLOW, LS_BLACK, 1);
   ega_writecharacter('e', 18, 10, LS_YELLOW, LS_BLACK, 2);
   ega_writecharacter('l', 24, 10, LS_YELLOW, LS_BLACK, 3);
   ega_writecharacter('l', 32, 10, LS_YELLOW, LS_BLACK, 4);
   ega_writecharacter('o', 40, 10, LS_YELLOW, LS_BLACK, 5);
   ega_writecharacter(' ', 48, 10, LS_YELLOW, LS_BLACK, 6);
   ega_writecharacter('W', 56, 10, LS_YELLOW, LS_BLACK, 7);
   ega_writecharacter('o', 64, 10, LS_YELLOW, LS_BLACK, 8);
   ega_writecharacter('r', 72, 10, LS_YELLOW, LS_BLACK, 9);
   ega_writecharacter('l', 80, 10, LS_YELLOW, LS_BLACK, 10);
   ega_writecharacter('d', 88, 10, LS_YELLOW, LS_BLACK, 11);
   ega_writecharacter('!', 96, 10, LS_YELLOW, LS_BLACK, 12);

   /* Small font was not used, so use it for the key message */
   ega_writetext(10, 40, LS_WHITE, LS_BLUE, SMALL_FONT,
                 "Press a key to continue!");

   /* Wait for key, return to text and exit */
   getxch();
   set80x25();
}
