#include <stdio.h>
#include <stdlib.h>
#include <dos.h>
#include <errno.h>
#include <direct.h>


void makesafe( struct _find_t *pfind);


main(int argc, char *argv[])
{
    int retval;
    int count = 0;
    unsigned curdisk;
    char *desired_path;
    char curdrive, desired_drive;
    char curdirect[_MAX_DIR];
    struct _find_t ffind;

    if (argc < 2) {
        fprintf(stderr,"\n\rUSAGE:    badfile path\n\r");
        fprintf(stderr,"    where path is the full path\n\r");
        fprintf(stderr,"    specified as IN in your tic.cfg\n\r");
        exit(255);
    }

    _dos_getdrive(&curdisk);
    _getcwd(curdirect,_MAX_DIR);

    desired_path = argv[1];

    if (desired_path[1] == ':') {  //drive specified in path
        desired_drive = toupper(desired_path[0]);
        desired_path += 2;
        _dos_getdrive(&curdisk);
        curdrive = 'A' + (curdisk -1);
        curdrive = 'A' + (curdisk -1);
        if (curdrive != desired_drive)
            _chdrive((desired_drive - 'A') + 1);
    }
    _chdir(desired_path);
    retval = _dos_findfirst("-*.*",_A_NORMAL,&ffind);
    if (retval== 0) {
        _mkdir(".\\badfiles");
        makesafe(&ffind);
        count++;
        while (!_dos_findnext(&ffind)) {
            count++;
            makesafe(&ffind);
        }
    }
    _chdrive(curdisk);
    _chdir(curdirect);
    exit(count);
}

void makenewname(int start, char *name)
{
    int i,j;
    char *s = name+start;

    for (i=start;i<strlen(name);i++,s++) {  // step through entire string
        for (j=0;j < 26; j++) {             // one character at time
            *s = 'a' + j;                   // incrementing char until
            if (_access(name,0) != 0)       // name does not exist
                break;
        }
        if (j < 26)
            break;
    }

}

void makesafe( struct _find_t *pfind)
{
    char newname[13];
    char buffer[_MAX_PATH];
    int retval,startpt = 0;;

    strcpy(newname,pfind->name);

    if( _getcwd(buffer,_MAX_DIR)== NULL) {
        makenewname(startpt,newname);
        rename(pfind->name,newname);
    }
    else if (strlen(buffer) >= (_MAX_DIR - 8)) {
        makenewname(startpt,newname);
        rename(pfind->name,newname);
    }
    else {
        strcat(buffer,"\\badfiles\\");
        startpt = strlen(buffer);
        strcat(buffer,newname);
        makenewname(startpt,buffer);
        rename(pfind->name,buffer);
    }
}
