/*  001  18-Apr-87  direct.h

        Copyright (c) 1987 by Blue Sky Software.  All rights reserved.
*/

/****************************************************************************/
/**** If ALTCALL is defined as pascal, make sure its defined in DIRECT.ASM **/
/****************************************************************************/

#define ALTCALL pascal         /* alternate calling method reduces overhead */

/* declare DIRECT.ASM and some OVTTY.C functions */

#ifdef LINT_ARGS
void ALTCALL gotorc(int, int);
void ALTCALL disp_str(char *);
void ALTCALL disp_char(int);
void ALTCALL disp_rep(int,int);
void ALTCALL insert_line(int,int);
void ALTCALL delete_line(int,int);
void ALTCALL popup(int,int,int,int,char *);
void ALTCALL popdwn(int,int,int,int,char *);
void ALTCALL scrcpy(char far *, char far *);
void ALTCALL setvattrib(int);
void ALTCALL disp_str_at(char *, int, int);
void ALTCALL disp_char_at(int, int, int);
void ALTCALL disp_rep_at(int, int, int, int);
void ALTCALL out_int(int, int, int);
void ALTCALL out_long(long, int, int);
void ALTCALL out_str(char *, int, int);
void ALTCALL clr_eol(void);
void clr_scr(void);
void init_tty(void);
void reinit_tty(void);
void reset_tty(void);
#else
void ALTCALL gotorc();
void ALTCALL disp_str();
void ALTCALL disp_char();
void ALTCALL disp_rep();
void ALTCALL insert_line();
void ALTCALL delete_line();
void ALTCALL popup();
void ALTCALL popdwn();
void ALTCALL scrcpy();
void ALTCALL setvattrib();
void ALTCALL disp_str_at();
void ALTCALL disp_char_at();
void ALTCALL disp_rep_at();
void ALTCALL out_int();
void ALTCALL out_long();
void ALTCALL out_str();
void ALTCALL clr_eol();
void clr_scr();
void init_tty();
void reinit_tty();
void reset_tty();
#endif
