// hello.h : Declares the class interfaces for the Hello child window.

#ifndef __HELLO_H__
#define __HELLO_H__

class CHelloWin : public CMDIChildWnd
    {
	short m_ColorID;
	COLORREF m_TextColor;
	CMenu* m_pMenuCurrent;
	BOOL m_bWindowActive;

public:
	BOOL Create(LPCSTR szTitle, 
                DWORD style = (WS_CHILD | WS_VISIBLE | WS_OVERLAPPEDWINDOW),
				const RECT& rect = rectDefault,
				CMDIFrameWnd* pParent = NULL);
	CHelloWin();
	virtual ~CHelloWin();

	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnDestroy();
	afx_msg void OnPaint();
	afx_msg void OnMDIActivate(BOOL bActivate,
					CWnd* pActivateWnd, CWnd* pDeactivateWnd);

	afx_msg void OnColor();
	DECLARE_MESSAGE_MAP()
    };

#endif // __HELLO_H__

