/*
**	INT15C.H - types and function prototypes.
**	IBM Personal Computer - TopView C Interface Header File.
**	Written for Borland Turbo C v1.5.
*/

typedef unsigned short WORD;	/* 16-bit value */
typedef unsigned long DWORD;	/* 32-bit value */
typedef void far *OBJECT;		/* object handle */

WORD pascal TopVer(void);	/* GET TOPVIEW VERSION (0 = NOT TOPVIEW) */

void pascal SetBit(			/* SETBIT POST FROM A 1ST-LEVEL INT HANDLER */
	WORD bit					/* bit to set */
);

typedef struct { WORD bxreg, cxreg, dxreg, direg, esreg; } REGLIST;

void pascal SubCall(		/* TOPVIEW SUBROUTINE CALL */
	WORD func_code,				/* function code */
	REGLIST *call_args			/* registers to/from */
);

typedef struct {			/* send message parameter list */
	WORD num_args;				/* number of arguments */
	DWORD arg[9];				/* 32-bit argument(s) */
} PARMLIST;

void pascal SendMsg(		/* SEND MESSAGE TO TOPVIEW OBJECT */
	WORD msg_num,				/* message number */
	WORD mod_num,				/* object modifier */
	OBJECT object_hdl,			/* object handle (0 = none) */
	PARMLIST *msg_args			/* parameter list & return value(s) */
);

/* end INT15C.H */
