#include "stdio.h"
#include "setjmp.h"
#include "isamstr.h"
#include "isam.h"

 /* checked good 6-7-84 */

 /***************************************************************
 *                      File ISAMB.C                            *
 *      this function creates an isam file.                     *
 *      filename= file name                                     *
 *      iflags = 1 for no duplicate keys, else 0                *
 *      max_m = # of possible main elements                     *
 *      max_l2 = # of possible l2 elements                      *
 *      max_l3 = # of possible l3 elements                      *
 *      max_r = # of possible recovery block elements           *
 *      ikeylen = length of a key in bytes                      *
 *      ireclen = length of a record in bytes                   *
 ***************************************************************/

char    *calloc();
int     creat(), write();

int    ind_build(filename, iflags, ikeylen, ireclen, max_m,
         max_l2, max_l3, max_r)

char   *filename, iflags;
unsigned ikeylen, ireclen, max_m, max_l2, max_l3, max_r;
{
   unsigned temp;

   index = (struct global *)calloc(1,sizeof(struct global));
   if(!index)
       return(NEM);
   keylen = ikeylen;
   reclen = ireclen;
   flags = iflags;
   m_max = max_m;
   l2_max = max_l2;
   l3_max = max_l3;
   r_max = max_r;
   l2bytes = sizeof(struct l2_link) + max_l2 * (sizeof(struct l2_elem) +
       ikeylen - 1);
   l3bytes = max_l3 * (sizeof(struct l3_elem) + ikeylen - 1);

   temp = sizeof(struct global) + ikeylen - 1 + max_m * (sizeof(
       struct m_elem) + ikeylen - 1) + l2bytes + l3bytes +
       (l2bytes > l3bytes ? l2bytes : l3bytes) + sizeof(
       struct recov) + (r_max - 1) * sizeof(long);

   ifd = creat(filename, 0x8002);
   if(ifd < 0) {
       free(index);
       return(CCF);
   }
/*  */
   if(write(ifd, &temp, sizeof(unsigned)) != sizeof(unsigned)) {
       free(index);
       return(IWE);
   }
   temp = lp_key - (char *)&keylen;
   ieof = temp + sizeof(unsigned) + max_m * (sizeof(struct m_elem)
       + keylen - 1);
   if(write(ifd, &keylen, temp) != temp) {
       free(index);
       return(IWE);
   }
   if(close(ifd)) {
       free(index);
       return(ICE);
   }
   free(index);
   return(0);
}
 /***************************************************************
 *                    end of function                           *
 ***************************************************************/
