/* --------------------- menuexmp.c ----------------------------- */

#include <stdio.h>
#include "toolset.h"
#include "screen.h"
#include "keys.h"
#include "menu.h"
int banner(), notimpl();

main()
{
	static char keytab [] = {F1, F2, F3};    /* Function keys              */
	static char alphtab [] = {'a', 's'};     /* Keystrokes for Menu 2      */
	static struct mif mf [] = {
    {"Main Menu", keytab,
        {{"F1 = Membership Maintenance",     0,    0,        "example.exe"},
         {"F2 = Mailing Labels",             2,    0,        ""},
         {"F3 = Membership Roster",          3,    0,        ""}}},
    {"Mailing Labels", alphtab,     
        {{"A-ll members",                    0,    notimpl,  ""},
         {"S-elected members",               4,    0,        ""}}},
    {"Membership Roster", keytab,   
        {{"F1 = Membership Number Sequence", 0,    notimpl,  ""},
         {"F2 = Member Name Sequence",       0,    0,   	   "sortexmp.exe"}}},
    {"Mailing Labels, Selected Members", 0, 
        {{"1 = Dues Notice Selection",       0,    notimpl,  ""},
         {"2 = Special Interest Selection",  0,    notimpl,  ""}}} 
	};
/*  Added by SP for documentation  */ 
/*     					pointer to menu tree 	    (*local)()	 extrnl pgm */		
    int minf = 1, sel = 0;

    menu_exec(mf, minf, sel, banner);
}

/* ------------- User's menu banner writer -------------- */
int banner()
{
    cursor(23, 3);
    printf("<< MEMBERSHIP ACCOUNTING SYSTEM >>");
}

/* ------------ a "stub" function ------------------ */
int notimpl(m, s)
int m, s;
{
    clr_scrn();
    printf("Not implemented ...");
    get_byte();
    return 0;
}
