/*  NUMLINES.C
 *  last mod.: 15-SEP-91
 */

#include <STDIO.H>
#include <L_FILE.H>

char *usage = "Use: NUMLINES filename\n";

/*  file must be a text file  */

/*----------------------------*/
void main(int argc, char **argv)
{
int err_flag, exclude_blank, type;
Uint num_lines, k;

if ( argc < 2 )
    {
    printf(usage);
    return;
    }

type = file_type(argv[1]);
if ( type == -2 )
    printf("File not found.\n");
else if ( type < 0 && type > -5 )
    printf("Error with this file.\n");
else if ( type != 2 )
    printf("This is not a text file.\n");
else
    {
    exclude_blank = TRUE;
    num_lines = num_lines_in_file(argv[1],exclude_blank,&err_flag);
    if ( err_flag )
        {
        switch ( err_flag )
            {
            case -2: printf("File not found.\n"); break;
            case -3: printf("Error opening file.\n"); break;
            case -4: printf("Error reading file.\n"); break;
            case -5: printf("File is empty.\n"); break;
            case -6: printf("Number of lines exceeds 65,565.\n"); break;
            case -7: printf("Less than 256 bytes free in near heap.\n"); break;
            default: printf("Unknown error.\n");
            }
        }
    else
        {
        printf("Non-blank lines in file =%5u\n",num_lines);
        k = num_lines;
        exclude_blank = FALSE;
        num_lines = num_lines_in_file(argv[1],exclude_blank,&err_flag);
        printf("Blank lines in file =    %5u\n",num_lines-k);
        printf("Total lines in file =    %5u\n",num_lines);
        }
    }
}
