// PARAMDLG.HXX - Parameters Dialog object



#ifndef CLASS_PARAMDLG
#define CLASS_PARAMDLG


#define  DEF_MAXEXTS     10
#define  DEF_SPECLEN     13



/////////////////////////////////////////////////////////////////////////////
// ParamDlg
/////////////////////////////////////////////////////////////////////////////
class THUGE ParamDlg : public ModalDlg
   {
   private  :
      char     szExts[ (DEF_SPECLEN * DEF_MAXEXTS)+1 ];
      BOOL     bFixed;
      BOOL     bSavePos;
      BOOL     bSaveParams;

   public   :
      FAR      ParamDlg( Window FAR *lpParentWindow, LPSTR lpszExtensions, BOOL bFixedFont, BOOL bSaveScreenPos, BOOL bSaveParameters );
      FAR     ~ParamDlg( void );

      BOOL  FAR   DlgMessageHandler( HWND hDlg, unsigned iMessage, WORD wParam, LONG lParam );

      int   FAR   GetFileExts( LPSTR lpszFileExts, int nMaxChars );
      BOOL  FAR   GetFixed( void )               { return( bFixed );      }
      BOOL  FAR   GetSavePos( void )             { return( bSavePos );    }
      BOOL  FAR   GetSaveParams( void )          { return( bSaveParams ); }
   };


#endif  // CLASS_PARAMDLG
