//==============================================================================================
//
//	Windows Interface Construction Set
//	Version 1.00
//
//	PCTBAR.H - Percent Bar Header File
//	Copyright  1993 by Microdyne Development Technologies.
//	All rights reserved.
//==============================================================================================

#ifndef _PCTBAR_H
#define _PCTBAR_H

#include <wics.h>
#include <control.h>

#pragma option -Vo-

_CLASSDEF (TPercentBar)

class TPercentBar : public TControl
{
private:
	virtual const Pchar streamableName() const { return "TPercentBar"; }

protected:
	virtual LPSTR GetClassName() { return "PercentBar"; }
	TPercentBar(StreamableInit) : TControl(streamableInit) {};

public:
	TPercentBar (PTWindowsObject AParent, int ResourceId, PTModule AModule = NULL);
	~TPercentBar ();

	virtual void SetLimit (long limit);
    virtual void SetBytesProcessed (long b);
};

#pragma option -Vo.

#endif