/* Types */

typedef struct {short a; short b; short c;} RB_PTR;

typedef char near *RB_SCHEMA;


/* Function Prototypes */

int    rbcreate
        (RB_SCHEMA*,	/* schema variable	*/
         unsigned,		/* page size		*/
         unsigned,		/* cache size		*/
         char*,			/* swap file name	*/
         RB_PTR*,		/* master record	*/
         unsigned);		/* master size		*/

int    rbopen
        (RB_SCHEMA*,	/* schema variable	*/
         unsigned,		/* cache size		*/
         char*,			/* swap file name	*/
         RB_PTR*);		/* master record	*/

RB_PTR rballoc
        (RB_SCHEMA,		/* schema variable	*/
         unsigned,		/* size				*/
         int*);			/* optional error	*/

char  *rbdemand
        (RB_SCHEMA,		/* schema variable	*/
         RB_PTR*,		/* pointer			*/
         int*);			/* optional error	*/

int    rbfree
        (RB_SCHEMA,		/* schema variable	*/
         RB_PTR*);		/* pointer			*/

int    rbcommit
        (RB_SCHEMA);	/* schema variable	*/

int    rbrollback
        (RB_SCHEMA);	/* schema variable	*/
