# Here is a sample make file showing the use of CHECKIN and CHECKOUT

ICFILES=	checkin.c filelist.c

IOFILES=	checkin.obj filelist.obj

OCFILES=	checkout.c filelist.c

OOFILES=	checkout.obj filelist.obj

LIBS=		item$(MMDL) block$(MMDL)

install:	CLEANUP PREP difs.exe mrgs.exe checkin.exe checkout.exe FINISH

CLEANUP:	
		@if exist error del error
		checkin -i pscm

PREP:		
		checkout -m pscm *.c *.h

FINISH:		
		checkout -e pscm *.c *.h

difs.exe:	difs.obj
		link difs.obj;

mrgs.exe:	mrgs.obj
		link mrgs.obj;

checkin.exe:	$(IOFILES)
		link $(IOFILES),checkin.exe,,$(LIBS);

checkout.exe:	$(OOFILES)
		link $(OOFILES),checkout.exe,,$(LIBS);

difs.obj:	mydefs.h

mrgs.obj:	mydefs.h

filelist.obj:	pscm.h

checkin.obj:	pscm.h

checkout.obj:	pscm.h
