// SAVASDLG.HXX - Save Page As Dialog object


#ifndef CLASS_EDITWINDOW
class THUGE EditWindow;
#endif

#ifndef CLASS_LISTBOXWINDOW
class THUGE ListboxWindow;
#endif


#ifndef CLASS_SAVASDLG
#define CLASS_SAVASDLG

// Limits
#define  DEF_FILENAMELEN      8
#define  DEF_FILEDIRLEN     242
#define  DEF_FILEEXTLEN       4
#define  DEF_FILEDRVLEN       2
#define  DEF_FILEANDPATH      DEF_FILENAMELEN+DEF_FILEDIRLEN+DEF_FILEEXTLEN+DEF_FILEDRVLEN


//////////////////////////////////////////////////////////////////////////////
// SaveAs File dialog
//////////////////////////////////////////////////////////////////////////////
class THUGE SaveAsDlg : public ModalDlg
   {
   private  :
      Window         FAR *lpParent;
      EditWindow     FAR *lpFileEdit;
      ListboxWindow  FAR *lpDirList;
      char                szFile[ DEF_FILENAMELEN+1 ];
      char                szDir[ DEF_FILEDIRLEN+1 ];
      char                szExt[ DEF_FILEEXTLEN+1 ];
      char                szDrive[ DEF_FILEDRVLEN+1 ];
      char                szFileName[ DEF_FILEANDPATH+1 ];

   public   :
      FAR      SaveAsDlg( Window FAR *lpParentWin, int nResID, LPSTR lpszFileName,  LPSTR lpszDefExt );
      FAR      SaveAsDlg( Window FAR *lpParentWin, LPSTR lpszResID, LPSTR lpszFileName, LPSTR lpszDefExt );
      FAR     ~SaveAsDlg( void );

      BOOL  FAR   DlgMessageHandler( HWND hDlg, unsigned iMessage, WORD wParam, LONG lParam );

      int   FAR   GetFileName( LPSTR lpszFileName, int nMaxChars = DEF_FILEANDPATH );
   };


#endif  // CLASS_SAVASDLG
