/******************************************************************************
* sfscr.c  - stantart function for screen handling.                           *
*                                                                             *
*                                                                             *
*                                                                             *
*                                                                             *
*                                                          09/19/88           *
******************************************************************************/




char sfscr_make_attr(int fg,int bg,int intensity,int blink);
/******************************************************************************
*  sfscr_make_attr   returns a one bye char screen attribute.                 *
*                                                                             *
*                                                                             *
*                    fg =  forground color SCR_RED or SCR_GREEN or SCR_GREEN  *
*                                          SCR_WHITE or SCR_YELLOW or         *
*                                          SCR_AQUA or SCR_MAGENTA or         *
*                                          SCR_BLACK                          *
*                                                                             *
*                   bg  =   background color  (use the above color codes      *
*                                                                             *
*                   indensity = indensity of foreground color SCR_DIM or      *
*                               SCR_BRIGHT                                    *
*                                                                             *
*                   blink     =  Blink foreground color  SCR_BLINK or         *
*                                SCR_NOBLINK                                  *
******************************************************************************/


void sfscr_get_attr(int attribute,int *fg,int *bg,int *intensity,int *blink);
/******************************************************************************
*  sfscr_get_attr   returns a the forground, bg, and intensity and blink      *
*                    value of a attribute passed to it.                       *
*                                                                             *
*                    attr = the attribute you wish to get values for.         *
*                                                                             *
*                    fg =  forground color SCR_RED or SCR_GREEN or SCR_GREEN  *
*                                          SCR_WHITE or SCR_YELLOW or         *
*                                          SCR_AQUA or SCR_MAGENTA or         *
*                                          SCR_BLACK                          *
*                                                                             *
*                   bg  =   background color  (use the above color codes      *
*                                                                             *
*                   indensity = indensity of foreground color SCR_DIM or      *
*                               SCR_BRIGHT                                    *
*                                                                             *
*                   blink     =  Blink foreground color  SCR_BLINK or         *
*                                SCR_NOBLINK                                  *
******************************************************************************/


void sfscr_get_cursor_loc(int *line,int *col);
/******************************************************************************
*  sfscr_get_cursor_loc    gets the current cursor line and column position   *
******************************************************************************/



void sfscr_set_cursor_loc(int line,int col);
/******************************************************************************
* sfscr_set_cur_loc - set location to line and column.                        *
******************************************************************************/
