// SRCHDLG.HXX - Search Dialog object



#ifndef CLASS_SEARCHDLG
#define CLASS_SEARCHDLG


class THUGE SearchDlg : public ModalDlg
   {
   private  :
      HANDLE      hSrchText;
      int         nMaxLen;
      BOOL        bCase;
      BOOL        bForward;

   public   :
      FAR      SearchDlg( Window FAR *lpParentWindow, int nResID,
                          LPSTR lpszSearchText,  int nMaxTextLen,
                          BOOL bCaseSensitive = FALSE,
                          BOOL bSearchForward = TRUE );

      FAR     ~SearchDlg( void );

      BOOL  FAR   DlgMessageHandler( HWND hDlg, unsigned iMessage, WORD wParam, LONG lParam );

      int   FAR   GetSearchText( LPSTR lpszSearchText, int nMaxChars );
      BOOL  FAR   IsCaseSensitive( void )            { return( bCase );      }
      BOOL  FAR   IsForwardSearch( void )                  { return( bForward );   }
      
   };


#endif  // CLASS_SEARCHDLG
