#ifndef __USETYPES_H
#define __USETYPES_H

//
// usetypes.h	- header file for class types designed by me
// Author		- Robin W. McKean
// Last Update	- February 19,1991
// Copyright (C) 1991 All rights reserved
//
// This file remains the property of the author, Robin W. McKean.  You are
// free to use and change it as you see fit.  This module, nor its object
// code, may not however be included  in any packaged software without the
// written consent of the author.
//

// Contents ----------------------------------------------------------------
//
//	eventClass
//
// Description
//
//		Defines types for the class library.
//
// End ---------------------------------------------------------------------

// Interface dependencies --------------------------------------------------

#ifndef _CLSTYPES_H
#include <clstypes.h>
#endif

// End Interface dependencies ----------------------------------------------

#define 	eventClass			( __firstUserClass + 0 )
#define 	deviceClass 		( eventClass + 1 )
#define 	cursorClass 		( deviceClass + 1 )
#define 	keyboardClass		( cursorClass + 1 )
#define 	mouseClass			( keyboardClass + 1 )
#define 	eventManagerClass	( mouseClass + 1 )
#define 	displayClass		( eventManagerClass + 1 )

#endif
