// viewer.h : Declares the class interfaces for the MDI sample application.

#ifndef __VIEWER_H__
#define __VIEWER_H__

#include<afxwin.h>
#include<afxdlgs.h>
#include<afxext.h>

#include"resource.h"
#include"common.h"
//#include"mydlgs.h"
#include"hello.h"
#include"bounce.h"
#include"filewin.h"
#include"bbutton.h"

class CMainWindow : public CMDIFrameWnd
    {
public:
	CMenu*    m_pMenuInit;

	CMainWindow(void);
	virtual ~CMainWindow(void);

	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnAbout(void);
	afx_msg void OnNewHello(void);
	afx_msg void OnNewBounce(void);
	afx_msg void OnExit(void);       
    afx_msg void OnNewFileWin(void);
    afx_msg void OnButtonTestDlg(void);

	// custom message and handler used by child windows to notify
	// parent of death
	afx_msg LONG OnChildDestroy(UINT wParam, LONG lParam);
	DECLARE_MESSAGE_MAP()
    };

class CTheApp : public CWinApp
    {
public:
	virtual BOOL InitInstance(void);
    };

#endif // __VIEWER_H__

