/* Light Speed Reference Example Program */
/* Find the page addresses of the current mode */
#include "lspeed.h"

main()
{
   /* Variables */
   unsigned int firstp, secondp;

   /* Set graphics mode, register font */
   set640x350();
   registerstandardfont();

   /* Assign the values, print output */
   firstp = ega_firstpageaddress();
   secondp = ega_secondpageaddress();
   ega_formattext(10, 10, LS_WHITE, LS_BLACK, STANDARD_FONT,
                  "First page address is %04X:0000", firstp);
   ega_formattext(10, 20, LS_WHITE, LS_BLACK, STANDARD_FONT,
                  "Second page address is %04X:0000", secondp);

   /* Wait for key, restore text, exit */
   ega_writetext(10, 30, LS_WHITE, LS_BLACK, STANDARD_FONT,
                 "Press a key...");
   getxch();
   set80x25();
}

 
