#define MAXFILES 600
#define FNASIZE  38912
#define ANY      FA_HIDDEN | FA_SYSTEM

void    help(void);
void    filecopy(FILE *fp);
int     getfnl(char *fnp, char *fna, unsigned fnasize, int attr);
int     strbpl(char *fpointers[], int maxcount, char *fna);

char    fnames[FNASIZE], *fpointers[MAXFILES];

char    *documentation[] = {
"CAT sucessively displays the contents of one or more files.  The resulting",
"output may be directed to your terminal (default), or to a file, or to your",
"printer or may be piped to another command.",
"",
"   Usage:  CAT <file list>",
"",
"The file list is a list of files (wildcards are acceptable).",
"",
"",
"Examples:",
"",
"    CAT file1 file2             file1+file2 copied to stdout",
"    CAT file1 file2 >file3      file1+file2 copied to file3",
"    CAT file1 file2 >lpt1       file1+file2 copied to LPT1",
"    CAT file1 file2 |more       file1+file2 piped through MORE",
"    CAT >test                   Same as \"COPY CON: test\"",
"    CAT >lpt1                   Same as \"COPY CON: LPT1\"",
0 };