#ifndef CURSOR_DEF
#define CURSOR_DEF
#include <proto.h>
#define CREATE_CURSOR_SHAPE(beginline,endline)  ((beginline)<<4+(endline))
#define THIN          0x0B0C
#define BLOCK         0x0007
#define INVISIBLE     0x1F00

#if __cplusplus
  extern "C" {
#endif
void GetCursorShape P((unsigned *, unsigned *));
void ChangeCursor P((unsigned, unsigned));
void BlockCursor P((void));
void ThinCursor P((void));
void HideCursor P((void));
#if _cplusplus
  }
#endif
#endif
