PAGE 80,132
TITLE DESQview TC 2.0 interfaces, SMALL Model, ver 2.0

; DESQC20S.ASM - DESQview interface routines
;  by  James H. LeMay, CIS 76011,217
;  for Eagle Performance Software
;      P.O. Box 122237
;      Ft. Worth, TX  76121
;
;  conversion to Turbo C by Jordan Gallagher / Wisdom Research
;
; These functions are published in the DESQview users manual and
; have been modified for use with TC 2.0.  Note that some of these
; routines are useful for direct screen writing utilities like QWKC20.ARC.
; Only uses approx. 93 bytes of code.

.MODEL SMALL

_TEXT  SEGMENT WORD PUBLIC 'CODE'

    DGROUP GROUP _DATA,_BSS
    ASSUME CS:_TEXT,DS:DGROUP,SS:DGROUP

_TEXT  ENDS


_DATA      SEGMENT WORD PUBLIC 'DATA'
D@         LABEL BYTE
D@W        LABEL WORD
_DATA      ENDS

_BSS       SEGMENT WORD PUBLIC 'BSS'
B@         LABEL BYTE
B@W        LABEL WORD
_BSS       ENDS


_DATA    SEGMENT WORD PUBLIC
         PUBLIC _in_dv

         _in_dv  DB  0        ; flag to tell whether DESQview is active
_DATA    ENDS


_TEXT    SEGMENT WORD PUBLIC
        PUBLIC  _dv_get_version
        PUBLIC  _dv_get_video_buffer
        PUBLIC  _dv_pause
        PUBLIC  _dv_begin_critical
        PUBLIC  _dv_end_critical

videoseg   EQU   [bp+4]

INCLUDE DSQCMAIN.ASM

_TEXT  ENDS

        END
