                              Chess Manual
                       Modified by Sysop Steve Lesner
                       Fido Nodes 141/260 and 141/261
                      Phones (203) 531-4289 - 531-4270

COMPILE INSTRUCTIONS:
GNUChess came from a UNIX environment but it ported quite well to OS/2.
I used the MSC 6.0 Compiler and am including my make file (GNUCHESS.MAK)
to use an example.  Naturally, one would have to go in and change the
directories (This can be done automatically in 6.0 and I'm not going to
elaborate here -- Call me and leave a message if you're confused) in the
makefile.

I also used a lot of fflush(stdout/in) commands to make sure that this
will run well with MAXPIPE.EXE.

SYSOP INSTRUCTIONS:
Simple, just copy all the non-src code files into a directory and call it
from max such as MAXPIPE.EXE GNUCHESS.EXE 5 60.  The 2 parameters set up
timing in the game and it makes it easier for the user to come into chess.
This parameters are explained later in this manual.

WARNINGS:
This game still uses things like save and get to actually give the user FULL
FREEDOM to save, get or even overwrite files!!!!  I do not list the save
or get commands in the help screen but I would RECOMEND going through the
source code completly to PULL OUT GET and SAVE or ANY OTHER disk writing
mechanisms available to your users!!!

INSTRUCTIONS:
Chess plays a game of chess against the user or it plays against itself.
Chess has a simple alpha-numeric board display or it can be compiled for
use with the CHESSTOOL program on a SUN workstation.
The program gets its opening moves from the file gnuchess.book which
should be located in the same directory as gnuchess.exe.

When Chess is invoked, the program will display the board and prompt the
user for a move. To enter a move, use the notation 'e2e4' where the first
letter-number pair indicates the origination square and the second
letter-number pair indicates the destination square.  An alternative
is to use the notation 'nf3' where the first letter indicates the piece
type (p,n,b,r,q,k).  To castle, type the origin and destination squares
of the king just as you would do for a regular move, or type the command
"o-o" for kingside castling and "o-o-o" for queenside.

In addition to legal moves, the following commands are available as responses.
beep
-- causes the program to beep after each move.
bd
-- updates the current board position on the display.
book
-- turns off use of the opening library.
both
-- causes the computer to play both sides of a chess game.
black
-- causes the computer to take the black pieces with the move
   and begin searching.
level
-- allows the user to set time controls such as
   60 moves in 5 minutes etc.  In tournament mode, the program will
   vary the time it takes for each
   move depending on the situation.  If easy mode is disabled (using
   the 'easy' command), the program
   will often respond with its move immediately, saving time on
   its clock for use later on.
depth
-- allows the user to change the
   search depth of the program.  The maximum depth is 29 ply.
   Normally the depth is set to 29 and the computer terminates
   its search based on elapsed time rather than depth.
   Using the depth command allows setting depth to say
   4 ply and setting response time to a large number such as
   9999 seconds. The program will then search until all moves
   have been examined to a depth of 4 ply (with extensions up
   to 11 additional ply for sequences of checks and captures).
easy
-- toggles easy mode (thinking on opponents time)
   on and off. The default is easy mode ON.  If easy mode is disabled,
   the user must enter a 'break' or '^C' to get the programs
   attention before entering each move.
edit
-- allows the user to set up a board position.
   In this mode, the '#' command will clear the board, the 'c'
   command will toggle piece color, and the '.' command will exit
   setup mode.  Pieces are entered by typing a letter (p,n,b,r,q,k) for
   the piece followed by the coordinate.  For example "pb3" would
   place a pawn on square b3.
force
-- allows the user to enter moves for both
   sides. To get the program to play after a sequence of moves
   has been entered use the 'white' or 'black' commands.
get
-- retrieves a game from disk.  The program will
   prompt the user for a file name.
help
-- displays a short description of the commands.
hint
-- causes the program to supply the user with
   its predicted move.
list
-- writes the game moves and some statistics
   on search depth, nodes, and time to the file 'chess.lst'.
new
-- starts a new game.
post
-- causes the program to display the principle
   variation and the score during the search.  A score of
   100 is equivalent to a 1 pawn advantage for the computer.
random
-- causes the program to randomize its move
   selection slightly.
reverse
-- causes the board display to be reversed.  That
   is, the white pieces will now appear at the top of the board.
quit
-- exits the game.
save
-- saves a game to disk.  The program will prompt
   the user for a file name.
switch
-- causes the program to switch places with
   the opponent and begin searching.
.PP
.I undo
-- undoes the last move whether it was the computer's
or the human's. You may also type "remove". This is equivalent
to two "undo's" (e.g. retract one move for each side).
white
-- causes the computer to take the white pieces
   with the move and begin searching.


       Pawn promotion to pieces other than a queen is not allowed.
          En-Passant does not work properly with CHESSTOOOL.
        The transposition table may not work properly in some
           positions so the default is to turn this off.
