// MEPEEK.CXX - MEPeekMsg Object Member functions  TIER 1 class
//              (C) Sturmer Hauss Corp. 1991


// Module Includes
#ifdef _TURBOL
extern "C"        {
#endif // _TURBOL

#define _TURBOAVOID


#ifdef _GLOCK20L
extern "C"        {
#endif // _GLOCK20L

#ifdef _ZTC201L
extern "Pascal"   {
#endif // _ZTC201L

#include <windows.h>          // Windows.H
#include <stdio.h>

#ifdef _GLOCK20L
                  }
#endif // _GLOCK20L

#ifdef _ZTC201L
                  }
#endif // _ZTC201L

#ifdef _TURBOL
                  }
#endif // _TURBOL



#include <t1types.hxx>     // just get the data types
#include <tierobj.hxx>
#include <tierwin.hxx>
#include <tierdlg.hxx>
#include <peekmsg.hxx>
#include "mepeek.hxx"




//////////////////////////////////////////////////////////////////////////////
// MEPeekMsg
//////////////////////////////////////////////////////////////////////////////
MEPeekMsg :: FAR MEPeekMsg( void )
   {
   // do nothing!
   }



MEPeekMsg :: FAR ~MEPeekMsg( void )
   {
   // do nothing!
   }



int MEPeekMsg :: FAR Begin( void )
   {
      static MSG      Msg;
      int             hAccel;
      BOOL            bProcess;
      HWND            hWndTemp = 0;
      int             nRet;

   if( (nRet = ::PeekMessage( &Msg, 0, 0, 0, PM_REMOVE )) )
      {
      bProcess = TRUE;
      
      // If the hwnd of the message is null then this
      // is probably a WM_QUIT message and we should
      // translate and dispatch it immediately.   
      if( !Msg.hwnd )
         {
         ::TranslateMessage( &Msg );
         ::DispatchMessage( &Msg );
         return( nRet );
         }

      // NOTE:  Only checking one level deep here.  If the user has created
      //        a dialog control in a modeless dialog that has a parent that
      //        is some other control in the modeless dialog this will not
      //        pick it up.  This is built this way for speed.

      if( ::IsModelessDialog( Msg.hwnd ) || ::IsModelessDialog( (hWndTemp = ::GetParent( Msg.hwnd )) ) )
         {
         if( hWndTemp )
            {
            if( ::IsDialogMessage( hWndTemp, &Msg ) )
               {
               bProcess = FALSE;
               }
            }
         else
            {
            if( ::IsDialogMessage( Msg.hwnd, &Msg ) )
               {
               bProcess = FALSE;
               }
            }

         }


      if( (hAccel = WinIsAccelTblLoaded( Msg.hwnd )) )
         {
         if( ::TranslateAccelerator( Msg.hwnd, hAccel, &Msg ) )
            {
            bProcess = FALSE;
            }
         }

      if( bProcess )
         {
         ::TranslateMessage( &Msg );
         ::DispatchMessage( &Msg );
         }

      }
   return( nRet );
   }
