// MEPRINT.CXX - Multi-Edit Printer class          (C) Sturmer Hauss Corp 1991




#define INCL_TIER_TYPES                    // data types like LONG, HWND, HANDLE
#define INCL_TIER_T1OBJECT                 // base class of the TIER1 Library and Window and Overlapped classes 
#define INCL_TIER_WINDOW                   // TIER Window class
   #define INCL_TIER_MDICLIENT             // MDI Client window class
   #define INCL_TIER_MDICHILD              // MDI Child window class
      #define INCL_TIER_DIALOG             // Dialog class
#define INCL_TIER_DC                       // DC, DeviceDC etc.
#define INCL_TIER_PEEKMSG                  // PeekMsg class  
#define INCL_TIER_PRINTER                  // Printer class



// Module includes .......................................................
#ifdef _TURBOL
extern "C"        {
#define __MSC
#endif // _TURBOL

#ifdef _GLOCK20L
extern "C"        {
#endif // _GLOCK20L

#ifdef _ZTC201L
extern "Pascal"   {
#endif // _ZTC201L

#include <stdio.h>       // sprintf(), fprintf()

#ifdef _GLOCK20L
                  }
#endif // _GLOCK20L

#ifdef _ZTC201L
                  }
#endif // _ZTC201L

#ifdef _TURBOL
                  }
#endif // _TURBOL


#include <tier1.hxx>    // TIER Library .hxx's
#include "defines.h"    // Our modules common #defines for the .RC file and here.
#include "mechild.hxx"  // MEChildWindow class
#include "mepeek.hxx"   // MEPeekMsg class
#include "meprint.hxx"  // This class



//////////////////////////////////////////////////////////////////////////////
// MEPrinter class
//////////////////////////////////////////////////////////////////////////////

MEPrinter :: FAR MEPrinter( MEChildWindow FAR *lpParentWin, DC FAR& oDC ) : (oDC)
   {
   // Initialize IVARS
   lpParent = lpParentWin;
   }



MEPrinter :: FAR ~MEPrinter( void )
   {
   // do nothing!
   }




short MEPrinter :: FAR AbortHandler( HANDLE hPrnDC, int nErrorCodes )
   {
      MEPeekMsg      peek;

   while( !lpParent->GetAbort() && peek.Begin() );

   return( !lpParent->GetAbort() );
   }
