/*  001  23-May-87  overr.h

        OverView internal error codes.

        Copyright (c) 1987 by Blue Sky Software.  All rights reserved.
*/

/* optins to show_error() */

#define SHOW_DOS (1)                   /* display DOS error msg */
#define QUIET    (2)                   /* don't beep            */

/* longjmp codes to show_error() */

#define CANT_OPEN    (1)
#define CANT_RMDIR   (2)
#define CANT_MKDIR   (4)
#define EMPTY_FILE   (6)
#define MUST_BE_DIR  (8)
#define NO_FND_STR   (10)
#define NO_MEM       (12)
#define NO_EXE_DIR   (14)
#define NO_EXT       (16)
#define NONE_TAGGED  (18)
#define ONE_SH_ALL   (20)
#define WIN_2_SMALL  (22)
#define STR_2_BIG    (23)
#define UNKN_MACRO   (24)
#define BAD_MACRO    (25)
#define BAD_UDK      (26)