/*  001  20-Apr-87  strmem.h

        Copyright (c) 1987 by Blue Sky Software.  All rights reserved.
*/

#define ALTCALL pascal         /* alternate calling method reduces overhead */

#define Malloc(i) mustalloc(i)         /* for cases where we must alloc */
#define Strdup(s) mustdup(s)           /* memory or we die */
#define Strndup(s,n) mustndup(s,n)

#ifdef LINT_ARGS
char * ALTCALL mustalloc(int);         /* Malloc() */
char * ALTCALL mustdup(char *);        /* Strdup() */
char * ALTCALL mustndup(char *, int);  /* Strndup() */
#else
char * ALTCALL mustalloc();            /* Malloc() */
char * ALTCALL mustdup();              /* Strdup() */
char * ALTCALL mustndup();             /* Strndup() */
#endif