;       Static Name Aliases
;
        TITLE   vputc
;       NAME    vputc.C

        .287
_TEXT   SEGMENT  BYTE PUBLIC 'CODE'
_TEXT   ENDS
_DATA   SEGMENT  WORD PUBLIC 'DATA'
_DATA   ENDS
CONST   SEGMENT  WORD PUBLIC 'CONST'
CONST   ENDS
_BSS    SEGMENT  WORD PUBLIC 'BSS'
_BSS    ENDS
DGROUP  GROUP   CONST,  _BSS,   _DATA
        ASSUME  CS: _TEXT, DS: DGROUP, SS: DGROUP, ES: DGROUP
_TEXT      SEGMENT

        PUBLIC  _vputc
_vputc  PROC NEAR
        push    bp
        mov     bp,sp
        push    si
        push    di

;       row = 4
;       col = 6
;       chr = 8
;       attr = 10
;       retrace = 12

        mov     ah,15
        int     10h
        cmp     al,7
        jne     $color
        mov     ax,0b000h
        xor     cx,cx
        jmp     short $offset
$color:
        mov     ax,0b800h
        mov     cx,[bp+12]            ;retrace
$offset:
        mov     es,ax

        mov     ax,160
        mov     bx,[bp+4]             ;row
        mul     bx
        mov     bx,[bp+6]             ;col
        shl     bx,1
        add     ax,bx
        mov     di,ax                 ;scr_ofs

        mov     ah,BYTE PTR [bp+10]      ;attr
        mov     al,BYTE PTR [bp+8]       ;chr

        jcxz    $stashit

        push    ax
        mov     dx,3dah
$WC23:
        in      al,dx
        test    al,1
        jne     $WC23
        cli

$WC25:
        in      al,dx
        test    al,1
        je      $WC25
        pop     ax

$stashit:
        stosw
        sti

        pop     di
        pop     si
        mov     sp,bp
        pop     bp
        ret

_vputc  ENDP
_TEXT   ENDS
END
