/* avg - print average and other statistics for input numbers
 */
#include "local.h"
main()
    {
    double x;
    double sum, xmin, xmax;
    int nnum, npos, nzero, nneg;

    sum = 0.;
    nnum = npos = nzero = nneg = 0;
    while (scanf("%lf", &x) == 1)
	{
	++nnum;
	if (x > 0.)
	    ++npos;
	else if (x == 0)
	    ++nzero;
	else
	    ++nneg;
	if (nnum == 1 || x < xmin)
	    xmin = x;
	else if (nnum == 1 || x > xmax)
	    xmax = x;
	sum += x;
	}
    if (nnum != 0)
	{
	printf("nnum  = %10d\n", nnum);
	printf("npos  = %10d\n", npos);
	printf("nzero = %10d\n", nzero);
	printf("nneg  = %10d\n", nneg);
	printf("avg   = %10.2f\n", sum / nnum); 
	printf("max   = %10.2f\n", xmax);
	printf("min   = %10.2f\n", xmin);
	}
    }
